#include <rt_fifo.h>
#include <linux/unistd.h>

#define __NR_rt_fifo_create   200
#define __NR_rt_fifo_destroy  201
#define __NR_rt_fifo_put      202
#define __NR_rt_fifo_get      203

_syscall2(int, rt_fifo_create, unsigned int, fifo, int, size);
_syscall1(int, rt_fifo_destroy, unsigned int, fifo);

_syscall3(int, rt_fifo_put, unsigned int, fifo, char *, buf, int, count);

_syscall3(int, rt_fifo_get, unsigned int, fifo, char *, buf, int, count);


#include <errno.h>
int rt_fifo_read(unsigned int fifo, char * buf, int count) 
{
	int ret;
	while ((ret = rt_fifo_get(fifo, buf, count)) < 0) {
	}
	return ret;
}

int rt_fifo_write(unsigned int fifo, char * buf, int count) 
{
	int ret;
	while ((ret = rt_fifo_put(fifo, buf, count)) < 0);
	return ret;
}

